package com.qihoo360.mobilesafe.lib.appmgr.service;

import com.qihoo360.mobilesafe.lib.appmgr.service.IUpgradeClient;
import com.qihoo360.mobilesafe.lib.appmgr.service.LastSavedInfo;

interface IUpgradeService {

    void addWatcher(IUpgradeClient client);
    
    void removeWatcher(IUpgradeClient client);
    
    void getUpgradeList(IUpgradeClient client);
    
    boolean getUpgradeListIfHave(IUpgradeClient client);  
    
    List<String> getDownloadPackage(IUpgradeClient client);
    
    void downloadPackage(IUpgradeClient client,String pkgName);
    
    void pauseDownload(IUpgradeClient client,String pkgName);
    
    void cancelDownload(IUpgradeClient client,String pkgName);
    
    void deleteDownload(IUpgradeClient client,String pkgName);
    
    void installPackage(IUpgradeClient client,String pkgName);  
    
    void ignorePackage(IUpgradeClient client,String pkgName, boolean bIgnore);
    
    void saveConfig(IUpgradeClient client);
    
    void saveLastInfo(IUpgradeClient client);
    
    LastSavedInfo getLastSavedInfo();
    
    boolean isRootReady();
}